<?php

include_once($config["base_path"]."/plugins/syslogupd/config.php");
#include_once("/plugins/syslogupd/config.php");
include_once('plugins/syslog/config.php');
include_once("lib/adodb/adodb.inc.php");
include_once("lib/database.php");
include_once("lib/functions.php");
//include_once($config["base_path"] . "/lib/poller.php");

global $sql_cnn_id;
/* db_connect_real - makes a connection to the database server
   @arg $host - the hostname of the database server, 'localhost' if the database server is running
      on this machine
   @arg $user - the username to connect to the database server as
   @arg $pass - the password to connect to the database server with
   @arg $db_name - the name of the database to connect to
   @arg $db_type - the type of database server to connect to, only 'mysql' is currently supported
   @arg $retries - the number a time the server should attempt to connect before failing
   @returns - (bool) '1' for success, '0' for error */
function sql_db_connect_real($host,$user,$pass,$db_name,$db_type, $port = "3307", $retries = 20) {
	global $sql_cnn_id;
	$i = 0;
	$sql_cnn_id = NewADOConnection($db_type);
	$hostport = $host . ":" . $port;
	while ($i <= $retries) {
		if ($sql_cnn_id->PConnect($hostport,$user,$pass,$db_name)) {
			return(1);
		}
		$i++;
		usleep(400000);
	}
//	cacti_log("ERROR: Cannot connect to MySQL server on '$host'. Please make sure you have specified a valid MySQL database name in 'include/config.php'.");
	return(0);
}

function sql_db_execute($sql) {
	global $sql_cnn_id;
	$query = $sql_cnn_id->Execute($sql);
	if ($query) {
		return(1);
	}else{
		return(0);
	}
}

function sql_db_request($sql,&$query) {
	global $sql_cnn_id;
	$query = $sql_cnn_id->Execute($sql);
	if ($query) {
		return(1);
	}else{
		return(0);
	}
}

function syslogupd_debug($string,$displaycmd=false)
{
        // use Cacti's debug log, if we are running from the poller
        if (function_exists('cacti_log') )
            { cacti_log(rtrim($string), $displaycmd, "SYSLOGUPD"); }
        else
        {
            $stderr=fopen('php://stderr', 'w');
            fwrite($stderr, $string);
            fclose ($stderr);
        }
}

function syslogupd_poller($forcedebug="") {
	global $config,$syslog_config,$syslogfile,$trapfile;
	global $syslogdb_hostname,$syslogdb_username,$syslogdb_password,$syslogdb_default,$syslogdb_type;
	global $action;
	global $sql_cnn_id;

        $nbrtraps=0;
	$res= sql_db_connect_real($syslogdb_hostname,$syslogdb_username,$syslogdb_password,$syslogdb_default, $syslogdb_type);

	if ($forcedebug=="full") {
	  $cactilog="sql connect RESULT=$res"
                    .",host=".$syslogdb_hostname.",user=".$syslogdb_username.",password=".$syslogdb_password
                    .",syslogdb_default=".$syslogdb_default.",syslogdb_type=".$syslogdb_type;
	  syslogupd_debug("CFG SYSLOGUPD DEBUG:$cactilog\n");
        }
        if (!file_exists($syslogfile)) {
 	  if ($forcedebug<>"") {
	      $cactilog="traps' file ($syslogfile) do not exist at this time.";
	      syslogupd_debug("CFG SYSLOGUPD DEBUG:$cactilog\n");
          }
          return;
        }
        if (file_exists($trapfile)) unlink($trapfile);
        rename($syslogfile,$trapfile);

	$showdescr = "describe $syslogdb_default.".$syslog_config["incomingTable"]." ";
	$resu = db_fetch_assoc($showdescr);
 	$tables = array();
        if ($resu) {
	  foreach($resu as $index => $arr) {
	  	if (array_key_exists("Field",$arr)) $tables[] = $arr["Field"];
	  }
	}

 	if ($forcedebug<>"") {
	      $cactilog="searching the traps.";
	      syslogupd_debug("CFG SYSLOGUPD DEBUG:$cactilog\n");
        }
       $handle = fopen($trapfile, "r");
        if ($handle) {
          while (!feof($handle)) {
           $line=fgets($handle);
          if ($line!="") {
            // insert record
            $nbrtraps = $nbrtraps+1;
            if (in_array("level", $tables) && in_array("program", $tables)) {
	     if ($forcedebug<>"") {
	        $cactilog="syslog with sqlrows 'level' & 'program'";
	        syslogupd_debug("CFG SYSLOGUPD DEBUG:$cactilog\n");
             }
             $record="(".$syslog_config["hostField"].","
                 .$syslog_config["facilityField"] . ","
                 .$syslog_config["priorityField"] . ","
                 ."level,"
                 .$syslog_config["dateField"] . ","
                 .$syslog_config["timeField"] . ","
                 ."program,"
                 .$syslog_config["textField"].")";
            } else {
             $record="(".$syslog_config["hostField"].","
                 .$syslog_config["facilityField"] . ","
                 .$syslog_config["priorityField"] . ","
                  .$syslog_config["dateField"] . ","
                 .$syslog_config["timeField"] . ","
                 .$syslog_config["textField"].")";
            }
            list($fulldate,$fulllevel,$host,$msg0) = preg_split('/,/', $line, 4);
            $msg1 = preg_replace('/"/', '%', $msg0);
            $msg = preg_replace("/'/", '%', $msg1);
	    $msg = rtrim($msg);
            $facility=""; $priority="";
            if ($fulllevel!="") list($facility,$priority) =
                 preg_split('/\./', $fulllevel, -1);
            if ($facility=="") $facility="local";
            if ($priority=="") $priority="notice";
            // filter
            if (preg_match('/ccmHistoryEventCommandSource/',$line)) {
            	$priority="info";
            }
            $level="";
            $date = date("Y-m-d",time());
            $time = date("H:m:s",time());
            if ($fulldate!="") list($date,$time)
            	     = preg_split('/ /', $fulldate, -1, PREG_SPLIT_NO_EMPTY);
            $program = "KIWI";
            if (in_array("level", $tables) && in_array("program", $tables)) {
              $values ="('".$host."','".$facility."','".$priority."','"
                      .$level."','".$date."','".$time."','"
                      .$program."','".$msg."')";
            } else {
              $values ="('".$host."','".$facility."','".$priority."','"
                      .$date."','".$time."','"
                      .$msg."')";
            }
            $table =$syslogdb_default.".".$syslog_config["incomingTable"];
            $sql_save="INSERT into $table $record VALUES$values ";
            $result = sql_db_execute($sql_save);
	    if ($forcedebug=="full") {
	      $cactilog="sql save command=$sql_save RESULT=$result";
	      syslogupd_debug("CFG SYSLOGUPD DEBUG:$cactilog\n");
            }
           }
	  }
	  if ($forcedebug=="full") {
	      $cactilog="END of copy traps to syslog.";
	      syslogupd_debug("CFG SYSLOGUPD DEBUG:$cactilog\n");
          }
         fclose($handle);
         //
         // optimize the DB 
	sql_db_execute("OPTIMIZE TABLE ".$syslogdb_default.".".$syslog_config["incomingTable"]);
	sql_db_execute("OPTIMIZE TABLE ".$syslogdb_default.".".$syslog_config["syslogTable"]);
	if ($nbrtraps>1) {
	      // start haloe/syslog_process.php for immediate update
              $debg= ($forcedebug<>"") ? " -d ": "";
	      $command_string = read_config_option("path_php_binary");
	      $command_string = "c:/php/php.exe";
	      $p = $config["base_path"] . "/plugins/syslog";
//	      $p = dirname(__FILE__);
	      if ($config["cacti_server_os"] == "unix") {
		$extra_args = "-q " . $p . "/syslog_process.php";
	      } else {
		$extra_args = "-q " . strtolower($p . "/syslog_process.php");
	      }
	      system("$command_string $extra_args", &$res);
	      if ($forcedebug<>"") {
	        $cactilog="exec system($command_string  $extra_args)";
	        syslogupd_debug("CFG SYSLOGUPD DEBUG:$cactilog RESULT=$res\n");
              }
//	      exec_background($command_string, $extra_args);
               // $res = system($command_string."$extra_args");
	   }
        }
}

?>